<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:13 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ProjectConnection (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ProjectConnection (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/tooling/ProgressListener.html" title="interface in org.gradle.tooling"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/tooling/ResultHandler.html" title="interface in org.gradle.tooling"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/tooling/ProjectConnection.html" target="_top">Frames</a></li>
<li><a href="ProjectConnection.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.tooling</div>
<h2 title="Interface ProjectConnection" class="title">Interface ProjectConnection</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="strong">ProjectConnection</span></pre>
<div class="block"><p>Represents a long-lived connection to a Gradle project. You obtain an instance of a <code>ProjectConnection</code> by using <a href="../../../org/gradle/tooling/GradleConnector.html#connect()"><code>GradleConnector.connect()</code></a>.</p>

 <pre class='autoTested'>
 ProjectConnection connection = GradleConnector.newConnector()
    .forProjectDirectory(new File("someFolder"))
    .connect();

 try {
    //obtain some information from the build
    BuildEnvironment environment = connection.model(BuildEnvironment.class)
      .get();

    //run some tasks
    connection.newBuild()
      .forTasks("tasks")
      .setStandardOutput(System.out)
      .run();

 } finally {
    connection.close();
 }
 </pre>

 <h3>Thread safety information</h3>

 <p>All implementations of <code>ProjectConnection</code> are thread-safe, and may be shared by any number of threads.</p>

 <p>All notifications from a given <code>ProjectConnection</code> instance are delivered by a single thread at a time. Note, however, that the delivery thread may change over time.</p></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../org/gradle/tooling/BuildActionExecuter.html" title="interface in org.gradle.tooling">BuildActionExecuter</a>&lt;T&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#action(org.gradle.tooling.BuildAction)">action</a></strong>(<a href="../../../org/gradle/tooling/BuildAction.html" title="interface in org.gradle.tooling">BuildAction</a>&lt;T&gt;&nbsp;buildAction)</code>
<div class="block">Creates an executer which can be used to run the given action.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#close()">close</a></strong>()</code>
<div class="block">Closes this connection.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#getModel(java.lang.Class)">getModel</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Fetches a snapshot of the model of the given type for this project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;void</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#getModel(java.lang.Class,%20org.gradle.tooling.ResultHandler)">getModel</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType,
        <a href="../../../org/gradle/tooling/ResultHandler.html" title="interface in org.gradle.tooling">ResultHandler</a>&lt;? super T&gt;&nbsp;handler)</code>
<div class="block">Starts fetching a snapshot of the given model, passing the result to the given handler when complete.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../org/gradle/tooling/ModelBuilder.html" title="interface in org.gradle.tooling">ModelBuilder</a>&lt;T&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#model(java.lang.Class)">model</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Creates a builder which can be used to query the model of the given type.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../org/gradle/tooling/BuildLauncher.html" title="interface in org.gradle.tooling">BuildLauncher</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#newBuild()">newBuild</a></strong>()</code>
<div class="block">Creates a launcher which can be used to execute a build.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../org/gradle/tooling/TestLauncher.html" title="interface in org.gradle.tooling">TestLauncher</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/ProjectConnection.html#newTestLauncher()">newTestLauncher</a></strong>()</code>
<div class="block">Creates a test launcher which can be used to execute tests.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getModel(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModel</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;getModel(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)
           throws <a href="../../../org/gradle/tooling/GradleConnectionException.html" title="class in org.gradle.tooling">GradleConnectionException</a>,
                  <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></pre>
<div class="block">Fetches a snapshot of the model of the given type for this project. This method blocks until the model is available.

 <p>This method is simply a convenience for calling <code>model(modelType).get()</code></p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The model.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/gradle/tooling/UnsupportedVersionException.html" title="class in org.gradle.tooling">UnsupportedVersionException</a></code> - When the target Gradle version does not support the given model.</dd>
<dd><code><a href="../../../org/gradle/tooling/UnknownModelException.html" title="class in org.gradle.tooling">UnknownModelException</a></code> - When the target Gradle version or build does not support the requested model.</dd>
<dd><code><a href="../../../org/gradle/tooling/BuildException.html" title="class in org.gradle.tooling">BuildException</a></code> - On some failure executing the Gradle build, in order to build the model.</dd>
<dd><code><a href="../../../org/gradle/tooling/GradleConnectionException.html" title="class in org.gradle.tooling">GradleConnectionException</a></code> - On some other failure using the connection.</dd>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></code> - When this connection has been closed or is closing.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
<a name="getModel(java.lang.Class, org.gradle.tooling.ResultHandler)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModel</h4>
<pre>&lt;T&gt;&nbsp;void&nbsp;getModel(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType,
                <a href="../../../org/gradle/tooling/ResultHandler.html" title="interface in org.gradle.tooling">ResultHandler</a>&lt;? super T&gt;&nbsp;handler)
              throws <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></pre>
<div class="block">Starts fetching a snapshot of the given model, passing the result to the given handler when complete. This method returns immediately, and the result is later
 passed to the given handler's <a href="../../../org/gradle/tooling/ResultHandler.html#onComplete(T)"><code>ResultHandler.onComplete(Object)</code></a> method.

 <p>If the operation fails, the handler's <a href="../../../org/gradle/tooling/ResultHandler.html#onFailure(org.gradle.tooling.GradleConnectionException)"><code>ResultHandler.onFailure(GradleConnectionException)</code></a> method is called with the appropriate exception.
 See <a href="../../../org/gradle/tooling/ProjectConnection.html#getModel(java.lang.Class)"><code>getModel(Class)</code></a> for a description of the various exceptions that the operation may fail with.

 <p>This method is simply a convenience for calling <code>model(modelType).get(handler)</code></p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type.</dd><dd><code>handler</code> - The handler to pass the result to.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></code> - When this connection has been closed or is closing.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
<a name="newBuild()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>newBuild</h4>
<pre><a href="../../../org/gradle/tooling/BuildLauncher.html" title="interface in org.gradle.tooling">BuildLauncher</a>&nbsp;newBuild()</pre>
<div class="block">Creates a launcher which can be used to execute a build.

 <p>Requires Gradle 1.0-milestone-8 or later.</p></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The launcher.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
<a name="newTestLauncher()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>newTestLauncher</h4>
<pre><a href="../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../org/gradle/tooling/TestLauncher.html" title="interface in org.gradle.tooling">TestLauncher</a>&nbsp;newTestLauncher()</pre>
<div class="block">Creates a test launcher which can be used to execute tests.

 <p>Requires Gradle 2.6 or later.</p></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The launcher.</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.6</dd></dl>
</li>
</ul>
<a name="model(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>model</h4>
<pre>&lt;T&gt;&nbsp;<a href="../../../org/gradle/tooling/ModelBuilder.html" title="interface in org.gradle.tooling">ModelBuilder</a>&lt;T&gt;&nbsp;model(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</pre>
<div class="block">Creates a builder which can be used to query the model of the given type.

 <p>Any of following models types may be available, depending on the version of Gradle being used by the target
 build:

 <ul>
     <li><a href="../../../org/gradle/tooling/model/gradle/GradleBuild.html" title="interface in org.gradle.tooling.model.gradle"><code>GradleBuild</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/build/BuildEnvironment.html" title="interface in org.gradle.tooling.model.build"><code>BuildEnvironment</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/GradleProject.html" title="interface in org.gradle.tooling.model"><code>GradleProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/gradle/BuildInvocations.html" title="interface in org.gradle.tooling.model.gradle"><code>BuildInvocations</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/gradle/ProjectPublications.html" title="interface in org.gradle.tooling.model.gradle"><code>ProjectPublications</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/idea/IdeaProject.html" title="interface in org.gradle.tooling.model.idea"><code>IdeaProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/idea/BasicIdeaProject.html" title="interface in org.gradle.tooling.model.idea"><code>BasicIdeaProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/eclipse/EclipseProject.html" title="interface in org.gradle.tooling.model.eclipse"><code>EclipseProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/eclipse/HierarchicalEclipseProject.html" title="interface in org.gradle.tooling.model.eclipse"><code>HierarchicalEclipseProject</code></a></li>
 </ul>

 <p>A build may also expose additional custom tooling models. You can use this method to query these models.

 <p>Requires Gradle 1.0-milestone-8 or later.</p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type</dd>
<dt><span class="strong">Returns:</span></dt><dd>The builder.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
<a name="action(org.gradle.tooling.BuildAction)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>action</h4>
<pre><a href="../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
&lt;T&gt;&nbsp;<a href="../../../org/gradle/tooling/BuildActionExecuter.html" title="interface in org.gradle.tooling">BuildActionExecuter</a>&lt;T&gt;&nbsp;action(<a href="../../../org/gradle/tooling/BuildAction.html" title="interface in org.gradle.tooling">BuildAction</a>&lt;T&gt;&nbsp;buildAction)</pre>
<div class="block">Creates an executer which can be used to run the given action. The action is serialized into the build
 process and executed, then its result is serialized back to the caller.

 <p>Requires Gradle 1.8 or later.</p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The result type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>buildAction</code> - The action to run.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The builder.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>close</h4>
<pre>void&nbsp;close()</pre>
<div class="block">Closes this connection. Blocks until any pending operations are complete. Once this method has returned, no more notifications will be delivered by any threads.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-3</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/tooling/ProgressListener.html" title="interface in org.gradle.tooling"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/tooling/ResultHandler.html" title="interface in org.gradle.tooling"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/tooling/ProjectConnection.html" target="_top">Frames</a></li>
<li><a href="ProjectConnection.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
